from direct.showbase.ShowBase import ShowBase
from panda3d.core import CollisionTraverser, CollisionHandlerQueue, CollisionNode, CollisionRay, BitMask32
from direct.interval.LerpInterval import LerpPosInterval

class Game(ShowBase):
    def __init__(self):
        ShowBase.__init__(self)

        self.replace = []

        node = loader.loadModel("a")
        node.reparentTo(render)
        node.setPos(-1.1, 1, 0)
        node.setCollideMask(BitMask32.bit(1))
        
        node1 = loader.loadModel("b")
        node1.reparentTo(render)
        node1.setPos(1.1, 0, 0)
        node1.setCollideMask(BitMask32.bit(1))

        base.accept('mouse1', self.pick)

        self.CurPicker = CollisionTraverser()
        #self.CurPicker.showCollisions(render)
        self.CurPickerOr = CollisionHandlerQueue()
        CurPickerNod = CollisionNode('mouseRay')
        CurPickerCam = camera.attachNewNode(CurPickerNod)
        CurPickerNod.setFromCollideMask(BitMask32.bit(1))
        self.CurPickerRay = CollisionRay()
        CurPickerNod.addSolid(self.CurPickerRay)
        self.CurPicker.addCollider(CurPickerCam, self.CurPickerOr)

    def pick(self):
       if base.mouseWatcherNode.hasMouse():
           mpos = base.mouseWatcherNode.getMouse()
           self.CurPickerRay.setFromLens(base.camNode, mpos.getX(), mpos.getY())
           self.CurPicker.traverse(render)
           self.CurPickerOr.sortEntries()
           
           if (self.CurPickerOr.getNumEntries() > 0):
            info = self.CurPickerOr.getEntry(0)

            self.replace.append(info.getIntoNodePath())

            if len(self.replace) >=2:
                LerpPosInterval(nodePath = self.replace[0], other = render, blendType = 'easeInOut', startPos = self.replace[0].getPos(render), duration = 1, bakeInStart = 1, pos = self.replace[1].getPos(render)).start()
                LerpPosInterval(nodePath = self.replace[1], other = render, blendType = 'easeInOut', startPos = self.replace[1].getPos(render), duration = 1, bakeInStart = 1, pos = (self.replace[0].getPos(render))).start()
                self.replace = []

game = Game()
game.run()